DROP TABLE IF EXISTS `#__securitycheckpro`;
CREATE TABLE `#__securitycheckpro` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`Product` VARCHAR(35) NOT NULL,
`sc_type` VARCHAR(35),
`Installedversion` VARCHAR(30) DEFAULT '---',
`Vulnerable` VARCHAR(10) NOT NULL DEFAULT 'No',
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_dynamic_blacklist`;
CREATE TABLE `#__securitycheckpro_dynamic_blacklist` (
`ip` VARCHAR(26) NOT NULL,
`timeattempt` DATETIME NOT NULL,
`counter` INT NOT NULL DEFAULT 1,
PRIMARY KEY (`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_vuln_components`;
CREATE TABLE `#__securitycheckpro_vuln_components` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`Product` VARCHAR(35) NOT NULL,
`vuln_id` INT(11) UNSIGNED NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_db`;
CREATE TABLE `#__securitycheckpro_db` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`Product` VARCHAR(35) NOT NULL,
`vuln_type` VARCHAR(35),
`Vulnerableversion` VARCHAR(10) DEFAULT '---',
`modvulnversion` VARCHAR(2) DEFAULT '==',
`Joomlaversion` VARCHAR(30) DEFAULT 'Notdefined',
`modvulnjoomla` VARCHAR(20) DEFAULT '==',
`description` VARCHAR(90),
`vuln_class` VARCHAR(70),
`published` VARCHAR(35),
`vulnerable` VARCHAR(70),
`solution_type` VARCHAR(35) DEFAULT '???',
`solution` VARCHAR(70),
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;
INSERT INTO `#__securitycheckpro_db` (`product`,`vuln_type`,`vulnerableversion`,`modvulnversion`,`Joomlaversion`,
`modvulnjoomla`,`description`,`vuln_class`,`published`,`vulnerable`,`solution_type`,`solution`) VALUES 
('Joomla!','core','3.0.0','==','3.0.0','==','Joomla! XSS Vulnerability','Typographical error','Oct 09 2012','Joomla! 3.0.0','update','3.0.1'),
('com_fss','component','1.9.1.1447','<=','3.0.0','>=','Joomla Freestyle Support Component','SQL Injection Vulnerability','Oct 19 2012','Versions prior to 1.9.1.1447','none','No details'),
('com_commedia','component','3.1','<=','3.0.0','>=','Joomla Commedia Component','SQL Injection Vulnerability','Oct 19 2012','Versions prior to 3.1','update','3.2'),
('Joomla!','core','3.0.1','<=','3.0.1','<=','Joomla! Core Clickjacking Vulnerability','Inadequate protection','Nov 08 2012','Joomla! 3.0.1 and 3.0.0 versions','update','3.0.2'),
('com_jnews','component','7.9.1','<','3.0.0','>=','Joomla jNews Component','Arbitrary File Creation Vulnerability','Nov 19 2012','Versions prior to 7.9.1','update','7.9.1'),
('com_bch','component','---','==','3.0.0','>=','Joomla Bch Component','Shell Upload Vulnerability','Dec 26 2012','Not especificed','none','No details'),
('com_aclassif','component','---','==','3.0.0','>=','Joomla Aclassif Component','Cross Site Scripting Vulnerability','Dec 26 2012','Not especificed','none','No details'),
('com_rsfiles','component','1.0.0 Rev 11','==','3.0.0','>=','Joomla RSFiles! Component','SQL Injection Vulnerability','Mar 19 2013','Version 1.0.0 Rev 11','update','1.0.0 Rev 12'),
('Joomla!','core','3.0.2','<=','3.0.2','<=','Joomla! XSS Vulnerability','Inadequate filtering','Apr 24 2013','Joomla! version 3.0.2 and earlier 3.0.x versions','update','3.1.0'),
('Joomla!','core','3.0.2','<=','3.0.2','<=','Joomla! DOS Vulnerability','Object unserialize method','Apr 24 2013','Joomla! version 3.0.2 and earlier 3.0.x versions','update','3.1.0'),
('Joomla!','core','3.0.2','<=','3.0.0','>=','Joomla! XSS Vulnerability','Inadequate filtering','Apr 24 2013','Joomla! version 3.0.2 and earlier 3.0.x versions','update','3.1.0'),
('Joomla!','core','3.0.2','<=','3.0.0','>=','Joomla! Information Disclosure Vulnerability','Inadequate permission checking','Apr 24 2013','Joomla! version 3.0.2 and earlier 3.0.x versions','update','3.1.0'),
('Joomla!','core','3.0.2','<=','3.0.0','>=','Joomla! XSS Vulnerability','Use of old version of Flash-based file uploader','Apr 24 2013','Joomla! version 3.0.2 and earlier 3.0.x versions','update','3.1.0'),
('Joomla!','core','3.0.2','<=','3.0.0','>=','Joomla! Privilege Escalation Vulnerability','Inadequate permission checking','Apr 24 2013','Joomla! version 3.0.2 and earlier 3.0.x versions','update','3.1.0'),
('Joomla!','core','3.0.2','<=','3.0.0','>=','Joomla! XSS Vulnerability','Inadequate filtering','Apr 24 2013','Joomla! version 3.0.2 and earlier 3.0.x versions','update','3.1.0'),
('com_jnews','component','8.0.1','<=','3.0.0','>=','Joomla Jnews Component','Cross Site Scripting Vulnerability','May 14 2013','Version 8.0.1 an earlier','update','8.1.x'),
('com_attachments','component','3.1.1','<','3.0.0','>=','Joomla Com_Attachments Component','Arbitrary File Upload Vulnerability','Jul 09 2013','Versions prior to 3.1.1','update','3.1.1'),
('System - Google Maps','plugin','3.1','<','3.0.0','>=','Joomla Googlemaps Plugin','XSS/XML Injection/Path Disclosure/DoS Vulnerabilities','Jul 17 2013','Version 3.1 and maybe above','update','3.1'),
('System - Google Maps','plugin','3.2','<=','3.0.0','>=','Joomla Googlemaps Plugin','XSS/DoS Vulnerabilities','Jul 26 2013','Version 3.2','update','3.x'),
('Joomla!','core','3.1.4','<=','3.0.0','>=','Joomla! Unauthorised Uploads Vulnerability','Inadequate filtering','Jul 31 2013','Joomla! 3.1.4 and earlier 3.x versions','update','3.1.5'),
('com_sectionex','component','2.5.96','<=','3.0.0','>=','Joomla SectionEx Component','SQL Injection Vulnerability','Aug 05 2013','Version 2.5.96 and maybe earlier','update','2.5.104'),
('com_joomsport','component','2.0.1','<','3.0.0','>=','Joomla joomsport Component','Multiple Vulnerabilities','Aug 20 2013','Versions prior to 2.0.1','update','2.0.1'),
('Joomla!','core','3.1.5','<=','3.0.0','>=','Joomla! XSS Vulnerability','Inadequate filtering','Nov 06 2013','Joomla! 3.1.5 and all earlier 3.x versions','update','3.2'),
('Joomla!','core','3.1.5','<=','3.0.0','>=','Joomla! XSS Vulnerability','Inadequate filtering','Nov 06 2013','Joomla! 3.1.5 and all earlier 3.x versions','update','3.2'),
('Joomla!','core','3.1.5','<=','3.0.0','>=','Joomla! XSS Vulnerability','Inadequate filtering','Nov 06 2013','Joomla! 3.1.5 and all earlier 3.x versions','update','3.2'),
('com_flexicontent','component','2.1.3','<=','3.0.0','>=','Joomla Flexicontent Component','Remote Code Execution Vulnerability','Dec 08 2013','Version 2.1.3 and earlier','none','No details'),
('com_mijosearch','component','2.0.1','<=','3.0.0','>=','Joomla MijoSearch Component','Cross Site Scripting/Exposure Vulnerability','Dec 16 2013','Version 2.0.1 and maybe earlier','update','2.0.4'),
('com_acesearch','component','3.0','==','3.0.0','>=','Joomla AceSearch Component','Cross Site Scripting Vulnerability','Jan 06 2014','Version 3.0','none','No details'),
('com_melody','component','1.6.25','<=','3.0.0','>=','Joomla Melody Component','Cross Site Scripting Vulnerability','Jan 10 2014','Version 1.6.25 and maybe earlier','none','No details'),
('com_sexypolling','component','1.0.8','<=','3.0.0','>=','Joomla Sexy Polling Component','SQL Injection Vulnerability','Jan 16 2014','Version 1.0.8 and maybe earlier','update','1.0.9'),
('com_komento','component','1.7.2','<=','3.0.0','>=','Joomla Komento Component','Cross Site Scripting Vulnerability','Jan 24 2014','Version 1.7.2 and maybe earlier','update','1.7.4'),
('com_community','component','2.6','==','3.0.0','>=','Joomla JomSocial Component','Code Execution Vulnerability','Jan 31 2014','Version 2.6','update','3.1.0'),
('Joomla!','core','3.2.2','<=','3.0.0','>=','Joomla! SQL Injection Vulnerability','Inadequate escaping','Mar 06 2014','Joomla! 3.1.0 through 3.2.2','update','3.2.3'),
('Joomla!','core','3.2.2','<=','3.0.0','>=','Joomla! XSS Vulnerability','Inadequate escaping','Mar 06 2014','Joomla! 3.1.2 through 3.2.2','update','3.2.3'),
('com_youtubegallery','component','3.4.0','==','3.0.0','>=','Joomla Youtube Gallery Component','Cross Site Scripting','Mar 15 2014','Version 3.4.0','update','3.8.3'),
('com_pbbooking','component','2.4','==','3.0.0','>=','Joomla Pbbooking Component','Cross Site Scripting','Mar 15 2014','Version 3.4.0','none','No details'),
('com_extplorer','component','2.1.3','==','3.0.0','>=','Joomla eXtplorer Component','Cross Site Scripting','Mar 15 2014','Version 2.1.3','update','2.1.5'),
('com_freichat','component','3.5','<=','3.0.0','>=','Joomla Freichat Component','Cross Site Scripting','Mar 15 2014','Version 3.4.0','none','No details'),
('com_multicalendar','component','4.0.2','==','3.0.0','>=','Joomla Multi Calendar Component','Cross Site Scripting','Mar 15 2014','Version 4.0.2','update','4.8.9'),
('com_kunena','component','3.0.4','==','3.0.0','>=','Joomla Kunena Component','Cross Site scripting Vulnerability','Mar 27 2014','Version 3.0.4','update','3.0.5'),
('com_jchat','component','2.2','==','3.0.0','>=','Joomla JChatSocial Component','Cross Site scripting Vulnerability','Jul 07 2014','Version 2.2 and maybe lower','update','2.3'),
('com_youtubegallery','component','4.1.7','<=','3.0.0','>=','Joomla Youtube Gallery Component','SQL Injection Vulnerability','Jul 17 2014','Version 4.1.7 and maybe lower','update','4.2.0'),
('com_kunena','component','3.0.5','==','3.0.0','>=','Joomla Kunena Component','Cross Site scripting Vulnerability','Jul 30 2014','Version 3.0.5','update','3.0.6'),
('com_kunena','component','3.0.5','==','3.0.0','>=','Joomla Kunena Component','SQL Injection Vulnerability','Jul 30 2014','Version 3.0.5','update','3.0.6'),
('com_spidervideoplayer','component','2.8.3','==','3.0.0','>=','Joomla Spider Video Player Component','SQL Injection Vulnerability','Aug 26 2014','Version 2.8.3','none','No details'),
('com_akeeba','component','3.11.4','<','3.0.0','>=','Joomla Akeeba Backup Component','Not specified','Aug 20 2014','Version 3.11.4 and lower','update','3.11.4'),
('com_spidercalendar','component','3.2.6','<=','3.0.0','>=','Joomla Spider Calendar Component','SQL Injection Vulnerability','Sept 08 2014','Version 3.2.6 and lower','update','3.2.7'),
('com_spidercontacts','component','1.3.6','<=','3.0.0','>=','Joomla Spider Contacts Component','SQL Injection Vulnerability','Sept 10 2014','Version 1.3.6 and lower','update','1.3.7'),
('com_formmaker','component','3.4.1','<','3.0.0','>=','Joomla Spider Form Maker Component','SQL Injection Vulnerability','Sept 12 2014','Version 3.4.0 and lower','update','3.4.1'),
('com_facegallery','component','1.0','==','3.0.0','>=','Joomla Face Gallery Component','SQL Injection / File Download Vulnerabilities','Sept 22 2014','Version 1.0','none','No details'),
('com_macgallery','component','1.5','<=','3.0.0','>=','Joomla Mac Gallery Component','Arbitrary File Download Vulnerability','Sept 22 2014','Version 1.5 and lower','none','No details'),
('Joomla!','core','3.3.4','<','3.0.0','>=','Joomla! XSS Vulnerability','Inadequate escaping','Sep 23 2014','Joomla! 3.3.0 through 3.3.3','update','3.3.4'),
('Joomla!','core','3.3.4','<','3.0.0','>=','Joomla! Unauthorised Logins Vulnerability','Inadequate checking','Sep 23 2014','Joomla! 3.3.0 through 3.3.4','update','3.3.4'),
('Joomla!','core','3.3.4','<=','3.0.0','>=','Joomla! Remote File Inclusion Vulnerability','Inadequate checking','Sep 30 2014','Joomla! 3.3.0 through 3.3.4','update','3.3.5'),
('Joomla!','core','3.3.4','<=','3.0.0','>=','Joomla! Denial of service Vulnerability','Inadequate checking','Sep 30 2014','Joomla! 3.3.0 through 3.3.4','update','3.3.5'),
('com_creativecontactform','component','2.0.0','<=','3.0.0','>=','Joomla Creative Contact Form Component','Shell Upload Vulnerability','Oct 23 2014','Version 2.0.0 and lower','none','No details'),
('com_xcloner-backupandrestore','component','3.5.1','==','3.0.0','>=','Joomla XCloner Component','Command Execution/Password Disclosure Vulnerabilities','Nov 07 2014','Version 3.5.1','update','3.5.2'),
('com_eventbooking','component','---','==','3.0.0','>=','Joomla EventBooking Component','Cross site scripting Vulnerability','Nov 13 2014','Not especificed','none','No details'),
('com_hdflvplayer','component','2.1.0.1','==','3.0.0','>=','Joomla HD FLV Component','SQL Injection Vulnerability','Nov 13 2014','Version 2.1.0.1','none','No details'),
('mod_simpleemailform','module','1.8.5','<=','3.0.0','>=','Simple Email Form Module','Cross site Scripting Vulnerability','Nov 19 2014','Version 1.8.5 and maybe lower','none','No details'),
('com_jclassifiedsmanager','component','2.0.0','<','3.0.0','>=','JClassifiedsManager Component','Cross Site Scripting/SQL Injection Vulnerabilities','Jan 26 2015','Versions prior to 2.0.0','update','2.0.0'),
('com_simplephotogallery','component','1.0','==','3.0.0','>=','Simple Photo Gallery Component','SQL Injection Vulnerability','Mar 16 2015','Version 1.0','update','1.1'),
('com_ecommercewd','component','1.2.5','==','3.0.0','>=','ECommerce-WD Component','SQL Injection Vulnerabilities','Mar 19 2015','Version 1.2.5','update','1.2.6'),
('com_spiderfaq','component','1.1','==','3.0.0','>=','Spider FAQ Component','SQL Injection Vulnerabilities','Mar 22 2015','Version 1.1','none','No details'),
('com_rand','component','1.5','==','3.0.0','>=','Spider Random Article Component','SQL Injection Vulnerabilities','Mar 25 2015','Version 1.5','none','No details'),
('com_gallery_wd','component','1.2.5','==','3.0.0','>=','Gallery WD Component','SQL Injection Vulnerabilities','Mar 30 2015','Version 1.2.5','none','No details'),
('com_contactformmaker','component','1.0.1','==','3.0.0','>=','Form Maker Component','SQL Injection Vulnerabilities','Mar 30 2015','Version 1.0.1','none','No details'),
('com_osproperty','component','2.8.0','<=','3.0.0','>=','OSProperty Component','SQL Injection Vulnerability','Apr 29 2015','Versions prior to 2.8.0 ','update','2.8.0'),
('com_eqfullevent','component','1.0.0','<=','3.0.0','>=','EQ Event Calendar Component','SQL Injection Vulnerability','Jun 8 2015','Version 1.0.0 and lower ','none','No details'),
('Joomla!','core','3.4.1','<=','3.0.0','>=','Joomla! Low level Vulnerability','Not especified','Jul 01 2015','Joomla! 3.x series','update','3.4.2'),
('com_kunena','component','4.0.2','==','3.0.0','>=','Joomla Kunena Component','Cross Site scripting Vulnerability','Jul 03 2015','Version 4.0.2','update','4.0.3'),
('com_j2store','component','3.1.6','==','2.5.0,3.0.0','>=,>=','Joomla J2Store Component','SQL Injection Vulnerabilities','Jul 11 2015','Version 3.1.6','update','3.1.7'),
('com_kunena','component','4.0.3','<=','2.5.0,3.0.0','>=,>=','Joomla Kunena Component','Full Path Disclosure Vulnerability','Jul 17 2015','Version 4.0.3 and lower','none','No details'),
('com_helpdeskpro','component','1.4.0','<','2.5.0,3.0.0','>=,>=','Joomla Helpdesk Pro Component','Multiple Vulnerabilities','Jul 21 2015','Version 1.4.0 and lower','update','1.4.0'),
('mod_jshopping_products_wfl','module','4.10.4','<=','3.0.0','>=','JoomShopping Module','Blind Sql injection Vulnerability','Aug 09 2015','Version 4.10.4 and lower','none','No details'),
('Joomla!','core','3.4.3','<=','3.0.0','>=','Joomla! Cross site scripting Vulnerability','Inadequate checking','Sep 09 2015','Joomla! 3.4 series','update','3.4.4'),
('com_komento','component','2.0.5','<','3.0.0','>=','Joomla Komento Component','Cross Site scripting Vulnerability','Oct 04 2015','Version 2.0.4 and lower','update','2.0.5'),
('Joomla!','core','3.4.4','<=','3.0.0','>=','Joomla! SQL Injection Vulnerability','Inadequate filtering','Oct 22 2015','Joomla! versions 3.2.0 through 3.4.4','update','3.4.5'),
('Joomla!','core','3.4.4','<=','3.0.0','>=','Joomla! ACL violations Vulnerability','Inadequate ACL checks','Oct 22 2015','Joomla! versions 3.2.0 through 3.4.4','update','3.4.5'),
('Joomla!','core','3.4.4','<=','3.0.0','>=','Joomla! ACL violations Vulnerability','Inadequate ACL checks','Oct 22 2015','Joomla! versions 3.0.0 through 3.4.4','update','3.4.5'),
('com_rpl','component','8.9.2','==','3.0.0','>=','Realtyna RPL Component','Multiple SQL Injection Vulnerabilities','Oct 23 2015','Version 8.9.2','update','8.9.3'),
('com_rpl','component','8.9.2','==','3.0.0','>=','Realtyna RPL Component','Persistent XSS And CSRF Vulnerabilities','Oct 23 2015','Version 8.9.2','update','8.9.3'),
('com_jnews','component','8.5.1','<=','2.5.0,3.0.0','>=,>=','Joomla JNews Component','Sql injection Vulnerability','Oct 29 2015','Version 8.5.1 and maybe lower','none','No details'),
('Joomla!','core','3.4.5','<=','3.0.0','>=','Joomla! Remote Code Execution Vulnerability','Browser information not filtered','Dec 14 2015','Joomla! versions 1.5.0 through 3.4.5','update','3.4.6'),
('Joomla!','core','3.4.5','<=','3.0.0','>=','Joomla! CSRF Vulnerability','CSRF','Dec 14 2015','Joomla! versions 3.2.0 through 3.4.5','update','3.4.6'),
('Joomla!','core','3.4.5','<=','3.0.0','>=','Joomla! Directory Traversa Vulnerability','Not sanitise input data','Dec 14 2015','Joomla! versions 3.4.0 through 3.4.5','update','3.4.6'),
('s5_media_player','plugin','2.0','==','2.5.0,3.0.0','>=,>=','Shape 5 MP3 Player Plugin','Local File Disclosure Vulnerability','Dec 14 2015','Version 2.0','none','No details'),
('Joomla!','core','3.4.6','<=','3.0.0','>=','Joomla! Session Hardening','Improved Session handling','Dec 21 2015','Joomla! versions 1.5.0 through 3.4.6','update','3.4.7'),
('Joomla!','core','3.4.6','<=','3.0.0','>=','Joomla! SQL Injection Vulnerability','Inadequate filtering of request data','Dec 21 2015','Joomla! versions 3.0.0 through 3.4.6','update','3.4.7'),
('fsave','plugin','2.0','==','2.5.0,3.0.0','>=,>=','Fsave Plugin','Local File Disclosure Vulnerability','Jan 20 2016','Version 2.0','none','No details'),
('com_pricelist','component','2.3.1','==','3.0.0','>=','Joomla Pricelist Component','Sql injection Vulnerability','Feb 07 2016','Version 2.3.1','update','3.3.0'),
('com_poweradmin','component','2.3.0','<=','3.0.0','>=','Joomla JSN PowerAdmin Component','Remote Command Execution Via CSRF and XSS vulnerabilities','Feb 25 2016','Version 2.3.0 and maybe lower','update','2.3.2'),
('com_easy_youtube_gallery','component','1.0.2','==','3.0.0','>=','Joomla Easy Youtube Gallery Component','SQL Injection vulnerability','Mar 23 2016','Version 1.0.2','none','No details'),
('com_icagenda','component','3.5.15','<=','2.5.0,3.0.0','>=,>=','iCagenda Component','Cross Site Scripting Vulnerability','Mar 23 2015','Version 3.5.5 up to 3.5.15','update','3.5.16'),
('mod_news_pro_gk5','module','1.9.3.4','<','2.5.0,3.0.0','>=,>=','News Show Pro GK5 Module','Sql injection Vulnerability','Apr 04 2016','Not specified','update','1.9.3.4'),
('com_jem','component','2.1.15','<=','2.5.0,3.0.0','>=,>=','Event Manager Component','Cross Site Scripting Vulnerability','May 14 2016','2.x versions','none','No details'),
('com_extplorer','component','2.1.9','==','2.5.0,3.0.0','>=,>=','Extplorer Component','Path traversal Vulnerability','May 16 2016','2.1.9 version','none','No details'),
('com_securitycheck','component','2.8.10','<','2.5.0,3.0.0','>=,>=','Securitycheck Component','XSS and Sql Injection Vulnerabilities','May 31 2016','2.8.9 version and lower','update','2.8.10'),
('com_securitycheckpro','component','2.8.10','<','2.5.0,3.0.0','>=,>=','Securitycheck Pro Component','XSS and Sql Injection Vulnerabilities','May 31 2016','2.8.9 version and lower','update','2.8.10'),
('com_jumi','component','3.0.5','==','2.5.0,3.0.0','>=,>=','Jumi Component','Cross site Scripting Vulnerability','Jun 03 2016','3.0.5','none','No details'),
('com_jobgrokapp','component','3.1-1.2.55','==','3.0.0','>=','Joomla JobGrokApp Component','SQL Injection vulnerability','Jun 07 2016','Version 3.1-1.2.55','none','No details'),
('com_joomdoc','component','4.0.3','==','2.5.0,3.0.0','>=,>=','JoomDoc Component','Path Disclosure Vulnerability','Jun 08 2016','4.0.3','none','No details'),
('com_payplans','component','3.3.6','==','3.0.0','>=','Pay Plans Component','SQL Injection Vulnerability','Jun 14 2016','3.3.6','none','No details'),
('com_affiliate','component','1.0.3','==','2.5.0','>=','Affiliate Component','SQL Injection Vulnerability','Jun 14 2016','1.0.3','none','No details'),
('com_maqmahelpdesk','component','4.2.3','==','3.0.0','>=','Maqma Helpdesk Component','Cross Site scripting Vulnerability','Jun 14 2016','4.2.3','none','No details'),
('com_affiliatetracker','component','2.0.3','==','2.5.0,3.0.0','>=,>=','Affiliate Tracker Component','SQL Injection Vulnerability','Jun 14 2016','2.0.3','none','No details'),
('com_enmasse','component','6.4','<=','3.0.0','>=','En-Masse Component','SQL Injection Vulnerability','Jun 15 2016','Versions 5.1 to 6.4','none','No details'),
('com_bt_media','component','1.0','==','2.5.0,3.0.0','>=,>=','BT Media Component','SQL Injection Vulnerability','Jun 20 2016','1.0','none','No details'),
('com_publisher','component','3.0.11','==','2.5.0,3.0.0','>=,>=','Publisher Component','SQL Injection Vulnerability','Jun 22 2016','3.0.11','none','No details'),
('com_services','component','---','==','3.0.0','>=','Services Component','SQL Injection Vulnerability','Jul 12 2016','Not specified','none','No details'),
('com_branch','component','3.0','==','3.0.0','>=','Branch Component','SQL Injection Vulnerability','Jul 12 2016','3.0','none','No details'),
('com_zhgooglemap','component','8.1.2.0','==','2.5.0,3.0.0','>=,>=','Zh GoogleMap Component','Blind SQL Injection Vulnerability','Jul 15 2016','8.1.2.0','none','No details'),
('com_guru','component','5.0.1','<=','2.5.0,3.0.0','>=,>=','Guru Pro Component','SQL Injection Vulnerability','Jul 14 2016','All versions','none','No details'),
('com_weblinks','component','---','==','2.5.0,3.0.0','>=,>=','Weblinks Component','Shell upload Vulnerability','Jul 26 2016','Not specified','none','No details'),
('com_gallery','component','1.1.5','==','3.0.0','>=','Huge IT Gallery Component','Cross Site scripting/SQL Injection vulnerabilities','Jul 26 2016','1.1.5','update','1.1.6'),
('com_catalog','component','1.0.4','==','3.0.0','>=','Huge IT Catalog Component','Cross Site scripting/SQL Injection vulnerabilities','Jul 27 2016','1.0.4','update','1.0.5'),
('com_slider','component','1.0.9','==','3.0.0','>=','Huge IT slider Component','Cross Site scripting/SQL Injection vulnerabilities','Jul 28 2016','1.0.9','none','No details'),
('com_breezingforms','component','1.8.7','<=','2.5.0,3.0.0','>=,>=','BreezingForms Component','Shell upload Vulnerability','Aug 03 2016','1.8.x branch','none','No details'),
('Joomla!','core','3.6.0','==','3.0.0','>=','Joomla! CSRF Vulnerability','csrf hardening','Aug 03 2016','Joomla! version 3.6.0','update','3.6.1'),
('com_videoflow','component','1.1.5','<=','2.5.0,3.0.0','>=,>=','Video Flow Component','SQL Injection Vulnerability','Aug 06 2016','1.1.3 to 1.1.5','update','1.2.0'),
('com_k2','component','2.7.1','<','2.5.0,3.0.0','>=,>=','K2 Component','Cross Site scripting Vulnerability','Aug 06 2016','Versions prior to 2.7.1','update','2.7.1');

DROP TABLE IF EXISTS `#__securitycheckpro_logs`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_logs` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`ip` VARCHAR(35) NOT NULL,
`geolocation` VARCHAR(150) DEFAULT '---',
`username` VARCHAR(150) DEFAULT '---',
`time` DATETIME NOT NULL,
`tag_description` VARCHAR(50),
`description` VARCHAR(300) NOT NULL,
`type` VARCHAR(50),
`uri` VARCHAR(100),
`component` VARCHAR(150) DEFAULT '---',
`marked` TINYINT(1) DEFAULT 0,
`original_string` VARCHAR(700),
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_own_logs`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_own_logs` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`time` DATETIME NOT NULL,
`description` VARCHAR(1200) NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_sessions`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_sessions` (
`userid` INT(4) UNSIGNED NOT NULL,
`session_id` VARCHAR(200) NOT NULL,
`username` VARCHAR(150) NOT NULL,
`ip` VARCHAR(26) NOT NULL,
`user_agent` VARCHAR(300) NOT NULL,
PRIMARY KEY (`userid`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_emails`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_emails` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`envoys` TINYINT(3) DEFAULT 0,
`send_date` DATE DEFAULT '2012-01-01',
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;
INSERT INTO `#__securitycheckpro_emails` (`envoys`,`send_date`) VALUES 
('0','2012-01-01');

DROP TABLE IF EXISTS `#__securitycheckpro_file_manager`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_file_manager` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`last_check` DATETIME,
`last_check_integrity` DATETIME,
`files_scanned` INT(10) DEFAULT 0,
`files_scanned_integrity` INT(10) DEFAULT 0,
`files_with_incorrect_permissions` INT(10) DEFAULT 0,
`files_with_bad_integrity` INT(10) DEFAULT 0,
`estado` VARCHAR(40) DEFAULT 'IN_PROGRESS',
`estado_integrity` VARCHAR(40) DEFAULT 'IN_PROGRESS',
`hash_alg` VARCHAR(30),
`estado_cambio_permisos` VARCHAR(40) DEFAULT 'IN_PROGRESS',
`estado_clear_data` VARCHAR(40) DEFAULT 'DELETING_ENTRIES',
`last_task` VARCHAR(40) DEFAULT 'INTEGRITY',
`cron_tasks_launched` TINYINT(1) DEFAULT 0,
`last_check_malwarescan` DATETIME,
`files_scanned_malwarescan` INT(10) DEFAULT 0,
`suspicious_files` INT(10) DEFAULT 0,
`estado_malwarescan` VARCHAR(40) DEFAULT 'IN_PROGRESS',
`last_online_check_malwarescan` DATETIME,
`online_checked_files` INT(4) DEFAULT 0,
`online_checked_hashes` INT(4) DEFAULT 0,
`last_check_database` DATETIME,
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;
INSERT INTO `#__securitycheckpro_file_manager` (`estado`,`estado_integrity`,`estado_cambio_permisos`,`estado_clear_data`,`estado_malwarescan`) VALUES 
('ENDED','ENDED','ENDED','DELETING_ENTRIES','ENDED');

DROP TABLE IF EXISTS `#__securitycheckpro_storage`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_storage` (
`storage_key` varchar(255) NOT NULL,
`storage_value` longtext NOT NULL,
PRIMARY KEY (`storage_key`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_rules`;
CREATE TABLE `#__securitycheckpro_rules` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`group_id` INT(10),
`rules_applied` TINYINT(1) DEFAULT 0,
`last_change` DATETIME,
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_rules_logs`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_rules_logs` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`ip` VARCHAR(35) NOT NULL,
`username` VARCHAR(150) NOT NULL,
`last_entry` DATETIME,
`reason` VARCHAR(300),
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_online_checks`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_online_checks` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`filename` VARCHAR(35) NOT NULL,
`files_checked` INT(3) DEFAULT 0,
`threats_found` INT(3) DEFAULT 0,
`scan_date` DATETIME,
`infected_files` VARCHAR(300) DEFAULT NULL,
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__securitycheckpro_update_database`;
CREATE TABLE IF NOT EXISTS `#__securitycheckpro_update_database` (
`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
`version` VARCHAR(10),
`last_check` DATETIME,
`message` VARCHAR(300),
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;
INSERT INTO `#__securitycheckpro_update_database` (`version`) VALUES ('1.0.53');

DROP TABLE IF EXISTS `#__securitycheckpro_users_control`;
CREATE TABLE `#__securitycheckpro_users_control` (
`id` INT(1) UNSIGNED NOT NULL AUTO_INCREMENT,
`users` VARCHAR(100) NOT NULL,
`contador` INT(3) UNSIGNED NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8;