<?php
defined('_JEXEC') or die;

$app             = JFactory::getApplication();
$doc             = JFactory::getDocument();
$user            = JFactory::getUser();
$this->language  = $doc->language;
$this->direction = $doc->direction;

$itemid = JRequest::getVar('Itemid');
$menu = &JSite::getMenu();
$active = $menu->getItem($itemid);
$params = $menu->getParams( $active->id );
$pageclass = $params->get( 'pageclass_sfx' );

// Getting params from template
$params = $app->getTemplate(true)->params;

// Detecting Active Variables
$option   = $app->input->getCmd('option', '');
$view     = $app->input->getCmd('view', '');
$layout   = $app->input->getCmd('layout', '');
$task     = $app->input->getCmd('task', '');
$itemid   = $app->input->getCmd('Itemid', '');
$sitename = $app->get('sitename');

if($task == "edit" || $layout == "form" )
{
  $fullWidth = 1;
}
else
{
  $fullWidth = 0;
}

// Add JavaScript Frameworks
JHtml::_('bootstrap.framework');
$doc->addScript('templates/' . $this->template . '/js/template.js');

// Add Stylesheets
$doc->addStyleSheet('templates/' . $this->template . '/css/template.css');

// Load optional RTL Bootstrap CSS
JHtml::_('bootstrap.loadCss', false, $this->direction);

?>
<!DOCTYPE html>
<html xmlns="http://ogp.me/ns#" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">
<head>
  
  <!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-174016497-1"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-174016497-1');
</script>
  
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="google-site-verification" content="BgSV6d6iCttcOmXevdMXXFTZgvvu49_r8IIE-w8yhkY" />
<jdoc:include type="head" /></jdoc:include>
<script src="templates/padraowebsite/js/menu-fixo.js"></script>
</head>

<body class="<?php echo $pageclass ? htmlspecialchars($pageclass) : ''; ?>">

 
  
<header>
<div id="logo">
  <div class="centro"><jdoc:include type="modules" name="logo" style="xhtml" /></div>
</div>

<div id="menuheight"></div>
<div id="menu">
  <jdoc:include type="modules" name="telefone" style="xhtml" />
  <jdoc:include type="modules" name="menu" style="xhtml" />
</div>

</header>

<?php if ($this->countModules('mobile')) : ?>
  <div id="mobile">
    <div class="mobile"><jdoc:include type="modules" name="mobile" style="xhtml" /></div>
  </div>
<?php endif; ?>

<?php if ($this->countModules('banner')) : ?>
<div class="banner"><jdoc:include type="modules" name="banner" style="xhtml" /></div>
<?php endif; ?>

<?php if ($this->countModules('servicos')) : ?>
<div id="servicos">
  <div class="centro"><jdoc:include type="modules" name="servicos" style="xhtml" /></div>
</div>
<?php endif; ?>

<div id="container">
  <div class="row-fluid">
  <main id="content" role="main" class="art-layout-cell">
    <!-- Begin Content -->
    <jdoc:include type="modules" name="position-3" style="xhtml" />
    <jdoc:include type="message" />
    <jdoc:include type="component" />
    <jdoc:include type="modules" name="position-2" style="xhtml" />
    <!-- End Content -->
    <?php if ($this->countModules('coluna-direito')) : ?>
    <div class="coluna-direito"><div class="direito-centro"><jdoc:include type="modules" name="coluna-direito" style="xhtml" /></div></div>
    <?php endif; ?>
  </main>
  </div>
</div>

<?php if ($this->countModules('solucoes')) : ?>
<div id="solucoes">
  <div class="centro"><jdoc:include type="modules" name="solucoes" style="xhtml" /></div>
</div>
<?php endif; ?>

<?php if ($this->countModules('frota')) : ?>
<div id="frota">
  <div class="centro"><jdoc:include type="modules" name="frota" style="xhtml" /></div>
</div>
<?php endif; ?>

<?php if ($this->countModules('blog')) : ?>
<div id="blog">
  <div class="centro"><jdoc:include type="modules" name="blog" style="xhtml" /></div>
</div>
<?php endif; ?>

<?php if ($this->countModules('blogdentro')) : ?>
<div id="blogdentro">
  <div class="centro"><jdoc:include type="modules" name="blogdentro" style="xhtml" /></div>
</div>
<?php endif; ?>


<div id="faleconosco">
  <div class="centro"><jdoc:include type="modules" name="faleconosco" style="xhtml" /></div>
</div>

<div id="rodape">
  <div class="centro"><jdoc:include type="modules" name="rodape" style="xhtml" /></div>
</div>

<div id="copyright">
  <div class="centro"><jdoc:include type="modules" name="copyright" style="xhtml" /></div>
</div>
</footer>

</body>
</html>

<!--[if IE]>
<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
<![endif]-->

<link href='https://fonts.googleapis.com/css?family=Roboto:400,300,300italic,400italic,500,500italic,700,700italic' rel='stylesheet' type='text/css'>
<link href='https://fonts.googleapis.com/css?family=Raleway:400,300,300italic,400italic,500,500italic,600,600italic,700,700italic' rel='stylesheet' type='text/css'>