﻿<?php 

/**
* @ author Jose A. Luque
* @ Copyright (c) 2011 - Jose A. Luque
* @license GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
*/

// Protect from unauthorized access
defined('_JEXEC') or die('Restricted access');
JRequest::checkToken() or die( 'Invalid Token' );

$status_array = array(JHtml::_('select.option','0', JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_TITLE_SUSPICIOUS')),
			JHtml::_('select.option','2', JText::_('COM_SECURITYCHECKPRO_FILEINTEGRITY_IN_EXCEPTIONS_LIST')),
			JHtml::_('select.option','3', JText::_('COM_SECURITYCHECKPRO_FILEINTEGRITY_QUARANTINED')));
			

// Add style declaration
$media_url = "media/com_securitycheckpro/stylesheets/cpanelui.css";
JHTML::stylesheet($media_url);

$bootstrap_css = "media/com_securitycheckpro/stylesheets/bootstrap.min.css";
JHTML::stylesheet($bootstrap_css);

$opa_icons = "media/com_securitycheckpro/stylesheets/opa-icons.css";
JHTML::stylesheet($opa_icons);

// Load Javascript
$document = JFactory::getDocument();
$document->addScript(rtrim(JURI::base(),'/').'/../media/com_securitycheckpro/javascript/jquery.js');
$document->addScript(rtrim(JURI::base(),'/').'/../media/com_securitycheckpro/javascript/bootstrap.js');
$document->addScript(rtrim(JURI::base(),'/').'/../media/com_securitycheckpro/javascript/bootstrap-modal.js');

$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn = $this->escape($this->state->get('list.direction'));

JHtml::_('formbehavior.chosen', 'select');
?>

<script type="text/javascript">
	jQuery(document).ready(function ($) {
		$('#tabs').tab();
	});	
</script> 


<div class="securitycheck-bootstrap">


<?php if ( $this->database_error == "DATABASE_ERROR" ) { ?>
<div class="alert alert-error">
	<?php echo JText::_('COM_SECURITYCHECKPRO_FILEMANAGER_DATABASE_ERROR'); ?>
</div>
<?php } ?>


<?php if ( $this->show_all == 1 ) { ?>
<div class="alert alert-info">
	<?php echo JText::_('COM_SECURITYCHECKPRO_FILEMANAGER_INFO'); ?>
</div>
<?php } ?>

<div class="alert alert-warn">
	<?php echo JText::_('COM_SECURITYCHECKPRO_MALWARE_FOUND_RECOMMENDATION'); ?>
</div>

<form action="<?php echo JRoute::_('index.php?option=com_securitycheckpro&controller=malwarescanstatus');?>" method="post" name="adminForm" id="adminForm">
<?php echo JHTML::_( 'form.token' ); ?>

<div>
	<ul id="tabs" class="nav nav-tabs" data-tabs="tabs">
		<li class="active"><a href="#patterns" data-toggle="tab"><?php echo JText::_( 'COM_SECURITYCHECKPRO_PATTERNS_FOUND' ); ?></a></li>
	</ul>

	<div id="my-tab-content" class="tab-content">
			<div class="tab-pane active" id="patterns">
			<div class="box-content">
			
				<?php if ( ($this->online_submission_type == "Hashes") && ($this->online_checked_hashes >= 1000) ) { ?>
				<div class="alert alert-error">
					<?php echo JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_HASHES_ALERT'); ?>
				</div>
				<?php } else if ( ($this->online_submission_type == "Files") && ($this->online_checked_files >= 25) ) { ?>
				<div class="alert alert-error">
					<?php echo JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_FILES_ALERT'); ?>
				</div>				
				<?php } ?>
				
				<?php if ( empty( $this->opswat_key ) ) { ?>
				<div class="alert alert-error">
					<?php echo JText::_('COM_SECURITYCHECKPRO_NO_API_KEY_ALERT'); ?>
				</div>
				<?php } ?>

				<div id="filter-bar" class="btn-toolbar">
					<div class="filter-search btn-group pull-left">
						<input type="text" name="filter_malwarescan_search" placeholder="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" id="filter_malwarescan_search" value="<?php echo $this->escape($this->state->get('filter.malwarescan_search')); ?>" title="<?php echo JText::_('JSEARCH_FILTER'); ?>" />
					</div>
					<div class="btn-group pull-left">
						<button class="btn tip" type="submit" rel="tooltip" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
						<button class="btn tip" type="button" onclick="document.getElementById('filter_malwarescan_search').value='';this.form.submit();" rel="tooltip" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>"><i class="icon-remove"></i></button>
					</div>
					
					<div class="btn-group pull-left">
						<select name="filter_malwarescan_status" class="inputbox" onchange="this.form.submit()">
							<option value=""><?php echo JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_STATUS_DESCRIPTION');?></option>
							<?php echo JHtml::_('select.options', $status_array, 'value', 'text', $this->state->get('filter.malwarescan_status'));?>
						</select>				
					</div>	
				</div>
				
				<?php
				if ( !empty($this->items) ) {		
				?>
				
				<div id="action_buttons" class="btn-toolbar">
				<div class="pull-right">

				<?php
				if ( !$this->state->get('filter.malwarescan_status') ) {		
				?>
					<button class="btn btn-success" onclick="Joomla.submitbutton('addfile_exception')" href="#">
						<i class="icon-plus-sign icon-white"> </i>
						<?php echo JText::_('COM_SECURITYCHECKPRO_ADD_AS_EXCEPTION'); ?>
					</button>					
				<?php	
					if ( !empty( $this->opswat_key ) ) { 
						if ( ($this->online_submission_type == "Files") && ($this->online_checked_files < 25) ) { ?>
							<button type="button" data-loading-text="<?php echo JText::_('COM_SECURITYCHECKPRO_SENDING_FILES'); ?>" class="btn btn-primary" onclick=" Joomla.submitbutton('online_check_files'); $(this).button('loading');" href="#">
								<i class="icon-upload icon-white"> </i>
								<?php echo JText::_('COM_SECURITYCHECKPRO_SCAN_FILES'); ?>
							</button>
					<?php } else if ( ($this->online_submission_type == "Hashes") && ($this->online_checked_hashes < 1000) ) { ?>
							<button type="button" data-loading-text="<?php echo JText::_('COM_SECURITYCHECKPRO_SENDING_HASHES'); ?>" class="btn btn-primary" onclick=" Joomla.submitbutton('online_check_hashes'); $(this).button('loading');" href="#">						
								<i class="icon-upload icon-white"> </i>
								<?php echo JText::_('COM_SECURITYCHECKPRO_SCAN_HASHES'); ?>
							</button>
					<?php } 				
					} ?>

				<?php
				} else if ( $this->state->get('filter.malwarescan_status') == 2 ) { ?>

					<button class="btn btn-danger" onclick="Joomla.submitbutton('deletefile_exception')" href="#">
						<i class="icon-trash icon-white"> </i>
						<?php echo JText::_('COM_SECURITYCHECKPRO_DELETE_EXCEPTION'); ?>
					</button>
						
				<?php  				
				} else if ( $this->state->get('filter.malwarescan_status') == 3 ) { ?>

					<button class="btn btn-info" onclick="Joomla.submitbutton('restore_quarantined_file')" href="#">
						<i class="icon-undo icon-white"> </i>
						<?php echo JText::_('COM_SECURITYCHECKPRO_RESTORE_QUARANTINED_FILE'); ?>
					</button>
					
					<button class="btn btn-danger" onclick="Joomla.submitbutton('delete_quarantined_file')" href="#">
						<i class="icon-trash icon-white"> </i>
						<?php echo JText::_('COM_SECURITYCHECKPRO_DELETE'); ?>
					</button>
						
				<?php } 				
				}
				?>							
			
			</div>
		</div>
								
				<div>
					<span class="badge" style="background-color: #FF9EB4; padding: 10px 10px 10px 10px;"><?php echo JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_RESULTS');?></span>
				</div>

				<table id="malwarescan_status_table" class="table table-bordered table-hover">
				<thead>
					<tr>
						<th class="malwarescan-table">
							<?php echo JText::_( 'COM_SECURITYCHECKPRO_FILEMANAGER_RUTA' ); ?>
						</th>
						<th class="malwarescan-table">
							<?php echo JText::_( 'COM_SECURITYCHECKPRO_FILEMANAGER_TAMANNO' ); ?>
						</th>
						<th class="malwarescan-table">
							<?php echo JText::_( 'COM_SECURITYCHECKPRO_FILEMANAGER_LAST_MODIFIED' ); ?>
						</th>
						<th class="malwarescan-table">
							<?php echo JText::_( 'COM_SECURITYCHECKPRO_MALWARESCAN_TYPE' ); ?>
						</th>
						<th class="malwarescan-table">
							<?php echo JText::_( 'COM_SECURITYCHECKPRO_MALWARESCAN_ALERT_LEVEL' ); ?>
						</th>
						<th class="malwarescan-table">
							<?php echo JText::_( 'COM_SECURITYCHECKPRO_MALWARESCAN_DESCRIPTION' ); ?>
						</th>
						<th class="malwarescan-table">
							<?php echo JText::_( 'COM_SECURITYCHECKPRO_MALWARESCAN_CODE_DESCRIPTION' ); ?>
						</th>
						<th class="malwarescan-table">

							<?php echo JText::_( 'COM_SECURITYCHECKPRO_MALWARESCAN_ONLINE_CHECK' ); ?>
						</th>
						<th class="malwarescan-table">
							<input type="checkbox" name="toggle" value="" onclick="Joomla.checkAll(this)" />							
						</th>
					</tr>
				</thead>
				<?php
				$k = 0;
				if ( !empty($this->items) ) {	
					foreach ($this->items as &$row) {
					$safe_malwarescan = $row['safe_malwarescan'];
				?>
					<td class="center">
						<?php echo $row['path']; ?>
						<br/>
						<?php 
							if ( $row['moved_to_quarantine'] == 1) {
								$span = "<span class=\"badge badge-info\">";
								echo $span . JText::_('COM_SECURITYCHECKPRO_MOVED_TO_QUARANTINE') . "</span>";
							}

						?>
					</td>
					<td class="center">
						<?php echo $row['size']; ?>
					</td>
					<td class="center">
						<?php echo $row['last_modified']; ?>
					</td>
					<td class="center">
						<?php echo $row['malware_type']; ?>
					</td>
					<td class="center">
						<?php
						switch ($row['malware_alert_level']) {
								case '0':
									$span = "<span class=\"badge badge-important\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_ALERT_LEVEL_0') . "</span>";							
									break;
								case '1':
									$span = "<span class=\"badge badge-warning\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_ALERT_LEVEL_1') . "</span>";
									break;
								case '2':
									$span = "<span class=\"badge\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_ALERT_LEVEL_2') . "</span>";
									break;
						} ?>						
					</td>
					<td class="center">
						<textarea cols="30" rows="1" readonly><?php echo str_replace('<br />', PHP_EOL, $row['malware_description']); ?></textarea>		
					</td>
					<td class="center">
						<textarea cols="30" rows="1" readonly><?php echo str_replace('<br />', PHP_EOL, $row['malware_code']); ?></textarea>		
					</td>
					<td class="center">
						<?php 
							switch ($row['online_check']) {
								case 0:
									$span = "<span class=\"badge badge-success\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_CLEAN') . "</span>";
									break;
								case 1:
									$span = "<span class=\"badge badge-important\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_INFECTED') . "</span>";							
									break;
								case 2:
									$span = "<span class=\"badge badge-warning\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_SUSPICIOUS') . "</span>";
									break;
								case 3:
									$span = "<span class=\"badge badge-inverse\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_FAILED_TO_SCAN') . "</span>";
									break;
								case 4:
									$span = "<span class=\"badge badge-inverse\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_CLEANED') . "</span>";
									break;
								case 5:
									$span = "<span class=\"badge badge-inverse\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_UNKNOW') . "</span>";
									break;
								case 6:
									$span = "<span class=\"badge badge-inverse\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_QUARANTINED') . "</span>";
									break;
								case 7:
									$span = "<span class=\"badge badge-inverse\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_SKIPPED_CLEAN') . "</span>";
									break;
								case 8:
									$span = "<span class=\"badge badge-inverse\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_SKIPPED_DIRTY') . "</span>";
									break;
								case 9:
									$span = "<span class=\"badge\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_EXCEEDED_DEPTH') . "</span>";
									break;
								case 10:
									$span = "<span class=\"badge\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_NOT_SCANNED') . "</span>";
									break;
								case 11:
									$span = "<span class=\"badge\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_ABORTED') . "</span>";
									break;
								case 12:
									$span = "<span class=\"badge\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_ENCRYPTED') . "</span>";
									break;
								case 13:
									$span = "<span class=\"badge\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_EXCEEDED_SIZE') . "</span>";
									break;
								case 14:
									$span = "<span class=\"badge\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_EXCEEDED_FILE_NUMBER') . "</span>";
									break;
								case 15:
									$span = "<span class=\"badge badge-inverse\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_HASH_NOT_FOUND') . "</span>";
									break;
								default:
									$span = "<span class=\"badge badge-info\">";
									echo $span . JText::_('COM_SECURITYCHECKPRO_MALWARESCAN_SCAN_RESULTS_NOT_CHECKED') . "</span>";
							}
						?>
					</td>
					<td class="center">
						<?php echo JHtml::_('grid.id', $k, $row['path'], '', 'malwarescan_status_table'); ?>		
					</td>
				</tr>
				<?php
					$k = $k+1;
					}
				}
				?>
				</table>
				
				<?php
				if ( !empty($this->items) ) {					
				?>
				<div class="margen">
				<tfoot>
					<tr>
						<td colspan="9"><?php echo $this->pagination->getListFooter(); echo $this->pagination->getLimitBox(); ?>						 
						</td>
					</tr>
				</tfoot>
				</div>
				<?php } ?>
				
		</div>
	</div>
			
	</div>
</div> 

<input type="hidden" name="option" value="com_securitycheckpro" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="1" />
</form>